///
pub struct Service {
  connection_broker: nats::asynk::Connection,
  queue_broker: String,
}

impl std::fmt::Debug for Service {
  fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
    f.debug_struct("Service of api.kgon.identity").finish()
  }
}

impl Service {
  ///
  pub fn new(connection_broker: nats::asynk::Connection, queue_broker: String) -> Service {
    Service {
      connection_broker,
      queue_broker,
    }
  }

  pub async fn subscribe(&self) -> std::result::Result<(), std::boxed::Box<dyn std::error::Error>> {
    futures::try_join!(
      self.create_deposit(),
      self.create_withdraw(),
      self.get_partner_balnace(),
      self.list_user_balnaces(),
      self.get_user_balnace(),
    )
    .map(|_| ())
  }

  async fn create_deposit(&self) -> Result<(), Box<dyn std::error::Error>> {
    Ok(())
  }
  async fn list_deposits(&self) -> Result<(), Box<dyn std::error::Error>> {
    Ok(())
  }
  async fn get_deposit(&self) -> Result<(), Box<dyn std::error::Error>> {
    Ok(())
  }
  async fn create_withdraw(&self) -> Result<(), Box<dyn std::error::Error>> {
    Ok(())
  }
  async fn list_withdraws(&self) -> Result<(), Box<dyn std::error::Error>> {
    Ok(())
  }
  async fn get_withdraw(&self) -> Result<(), Box<dyn std::error::Error>> {
    Ok(())
  }

  async fn get_partner_balnace(&self) -> Result<(), Box<dyn std::error::Error>> {
    Ok(())
  }
  async fn list_user_balnaces(&self) -> Result<(), Box<dyn std::error::Error>> {
    Ok(())
  }
  async fn get_user_balnace(&self) -> Result<(), Box<dyn std::error::Error>> {
    Ok(())
  }
}
